package com.ocity.api.core.application.heritage;

import com.ocity.api.core.application.heritage.dto.in.CategoriesDTO;
import com.ocity.api.core.domain.heritage.Type;
import com.ocity.api.core.domain.heritage.Types;
import org.springframework.stereotype.Component;

import java.util.Objects;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@Component
public class TypesMapper {

    public Types map(CategoriesDTO dto) {
        return Stream.of(
                        Boolean.TRUE.equals(dto.culturalType())? Type.CULTURAL : null,
                        Boolean.TRUE.equals(dto.naturalType())? Type.NATURAL : null,
                        Boolean.TRUE.equals(dto.mixedType())? Type.MIXED : null
                )
                .filter(Objects::nonNull)
                .collect(Collectors.collectingAndThen(Collectors.toList(), Types::new));
    }
}
