package com.ocity.api.core.application.heritage.dto.in;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public enum HeritageFormat {
    UNE(1),
    SCHEMA_ORG(2);

    private final int id;

    HeritageFormat(int id) {
        this.id = id;
    }

    public int getId() {
        return id;
    }

    private static final Map<Integer, HeritageFormat> HERITAGE_FORMAT_ID_MAP = new HashMap<>();

    static {
        Arrays.stream(HeritageFormat.values())
                .forEach(heritageFormat -> HERITAGE_FORMAT_ID_MAP.put(heritageFormat.id, heritageFormat));
    }

    public static HeritageFormat getById(int id) {
        return HERITAGE_FORMAT_ID_MAP.get(id);
    }
}
