package com.ocity.api.core.application.locations;

import com.ocity.api.core.application.locations.dto.out.RegionDTO;
import com.ocity.api.core.application.locations.dto.out.RegionDTOMapper;
import com.ocity.api.core.domain.locations.LocationsRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Comparator;
import java.util.List;

@Component
public class FindAllRegions {

    private final LocationsRepository locationsRepository;
    private final RegionDTOMapper regionDTOMapper;

    @Autowired
    public FindAllRegions(LocationsRepository locationsRepository, RegionDTOMapper regionDTOMapper) {
        this.locationsRepository = locationsRepository;
        this.regionDTOMapper = regionDTOMapper;
    }

    public List<RegionDTO> execute() {
        return locationsRepository.findAllRegions().stream()
                .map(regionDTOMapper::map)
                .sorted(Comparator.comparing(regionDTO -> regionDTO.name))
                .toList();
    }


}
