package com.ocity.api.core.application.locations;

import com.ocity.api.core.application.locations.dto.out.CityDTO;
import com.ocity.api.core.application.locations.dto.out.CityDTOMapper;
import com.ocity.api.core.domain.locations.LocationsRepository;
import com.ocity.api.core.domain.locations.StateId;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Comparator;
import java.util.List;

@Component
public class FindCitiesByStateId {

    private final LocationsRepository locationsRepository;
    private final CityDTOMapper cityDTOMapper;

    @Autowired
    public FindCitiesByStateId(LocationsRepository locationsRepository, CityDTOMapper cityDTOMapper) {
        this.locationsRepository = locationsRepository;
        this.cityDTOMapper = cityDTOMapper;
    }

    public List<CityDTO> execute(Integer stateId) {
        return locationsRepository.findCitiesByStateId(new StateId(stateId)).stream()
                .map(cityDTOMapper::map)
                .sorted(Comparator.comparing(cityDTO -> cityDTO.name))
                .toList();
    }
}
