package com.ocity.api.core.application.locations;

import com.ocity.api.core.application.locations.dto.out.StateDTO;
import com.ocity.api.core.application.locations.dto.out.StateDTOMapper;
import com.ocity.api.core.domain.locations.CountryId;
import com.ocity.api.core.domain.locations.LocationsRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Comparator;
import java.util.List;

@Component
public class FindStatesByCountryId {

    private final LocationsRepository locationsRepository;
    private final StateDTOMapper stateDTOMapper;

    @Autowired
    public FindStatesByCountryId(LocationsRepository locationsRepository, StateDTOMapper stateDTOMApper) {
        this.locationsRepository = locationsRepository;
        this.stateDTOMapper = stateDTOMApper;
    }

    public List<StateDTO> execute(Integer countryId) {
        return locationsRepository.findStatesByCountryId(new CountryId(countryId)).stream()
                .map(stateDTOMapper::map)
                .sorted(Comparator.comparing(stateDTO -> stateDTO.name))
                .toList();
    }
}
