package com.ocity.api.core.domain.heritage;

import com.ocity.api.core.application.heritage.dto.in.HeritageFormat;
import com.ocity.api.core.domain.locations.CityId;
import com.ocity.api.core.domain.locations.CountryId;
import com.ocity.api.core.domain.locations.RegionId;
import com.ocity.api.core.domain.locations.StateId;

import java.util.List;

public interface HeritageRepository {
    List<HeritageItem> findByRegionId(RegionId regionId, Types types, HeritageFormat heritageFormat);
    List<HeritageItem> findBySubregionId(SubregionId subregionId, Types types, HeritageFormat heritageFormat);
    List<HeritageItem> findByCountryId(CountryId regionId, Types types, HeritageFormat heritageFormat);
    List<HeritageItem> findByStateId(StateId stateId, Types types, HeritageFormat heritageFormat);
    List<HeritageItem> findByCityId(CityId cityId, Types types, HeritageFormat heritageFormat);
}
