package com.ocity.api.core.domain.heritage;

import org.apache.commons.lang3.Validate;

import java.util.List;
import java.util.Optional;

public class Links {

    private final UrlFriendly urlFriendly;
    private final List<Link> links;

    public Links(UrlFriendly urlFriendly, List<Link> links) {
        Validate.notNull(urlFriendly, "UrlFriendly cannot be null");
        this.urlFriendly = urlFriendly;
        this.links = links;
    }

    public UrlFriendly urlFriendly() {
        return urlFriendly;
    }

    public Optional<List<Link>> links() {
        return Optional.ofNullable(links);
    }
}
