package com.ocity.api.core.domain.heritage;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public enum Subtype {

    MONUMENTS_BUILDINGS_AND_HERITAGE_SITES(1),
    ARCHAEOLOGICAL_HERITAGE_ELEMENTS(2),
    URBAN_ELEMENTS(3),
    OTHERS(4),
    ARCHAELOGICAL_ELEMENTS(5),
    NATURAL_ELEMENT(6),
    OBJECTS_OF_ANTHROPOLOGICAL_OR_ETHNOLOGICAL_INTEREST(7),
    WORKS_OF_ART(8),
    ANTIQUES_WITH_A_HISTORICAL_AND_OR_SOCIAL_SIGNIFICANCE(9),
    ELEMENTS_RELATED_TO_TECHNOLOGY_AND_THE_SCIENCES(10),
    DOCUMENTARY_ELEMENTS(11),
    DISMEMBERED_ELEMENTS_FROM_ARTISTIC_OR_HISTORICAL_MONUMENTS_OR_ARCHAEOLOGICAL_SITES(12),
    ARTISTIC_AND_PERFORMING_MANIFESTATIONS_AND_EXPRESSIONS(13),
    LUDIC_EXPRESSION_AND_CELEBRATION(14),
    ORAL_TRADITION_AND_EXPRESSION(15),
    SOCIAL_USE_AND_PRACTICE(16),
    KNOWLEDGE_AND_PRACTICES_CONCERNING_NATURE_AND_THE_UNIVERSE(17),
    KNOWLEDGE_ON_TRADITIONAL_PRODUCTIVE_METHODS_AND_TECHNIQUES(18),
    CUSTOMARY_GOVERNANCE_SYSTEMS(19),
    AREA(20),
    MONUMENT(21),
    EVENT(22),
    FLORA_AND_FAUNA(23),
    CULTURAL_LANDSCAPE(24),
    DESIGNED_LANDSCAPE(25),
    TRADITIONAL_FORMS_OF_LAND_USE(26);

    private final Integer id;

    Subtype(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    private static final Map<Integer, Subtype> CATEGORY_FIELD_MAP = new HashMap<>();
    static {
        Arrays.stream(Subtype.values())
                .forEach(subtype -> CATEGORY_FIELD_MAP.put(subtype.id, subtype));
    }

    public static Subtype fromId(Integer id) {
        return CATEGORY_FIELD_MAP.get(id);
    }
}
