package com.ocity.api.core.domain.heritage;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public enum Tag {

    PUBLIC_CIVIL_BUILDINGS(1),
    DEFENSE_CONSTRUCTIONS(2),
    RELIGIOUS_CONSTRUCTIONS(3),
    TRADITIONAL_RURAL_CONSTRUCTIONS_OF_ETHNOGRAPHIC_VALUE(4),
    FUNERARY_CONSTRUCTIONS(5),
    RESIDENTIAL_BUILDINGS(6),
    HISTORIC_SITES_OR_PLACES_AND_COMMEMORATIVE_ELEMENTS(7),
    MINING_AND_INDUSTRIAL_HERITAGE_ELEMENTS(8),
    ARCHAEOLOGICAL_SITE(9),
    ROCKY_OR_PARIETAL_PAINTINGS(10),
    ARCHAEOLOGICAL_AREA(11),
    URBAN_LAYOUT(12),
    URBAN_LANDMARK(13),
    DISTRICTS(14),
    ENGINEERING_WORKS(15),
    MODERN_ARCHITECTURE(16),
    TECHNOLOGICAL_CENTRES(17),
    ARTEFACTS(18),
    OBJECTS_AND_STATUES_MADE_OF_STONE_WOOD_BONE_METAL_CERAMICS(19),
    TEXTILE_ELEMENTS(20),
    DECORATED_PLATELETS(21),
    HUMAN_OR_ANIMAL_BONES(22),
    MUMMIES(23),
    SHIPWRECKS(24),
    PALEONTOLOGICAL_REMAINS(25),
    METEORITICS(26),
    MINERALS_AND_GEMSTONES(27),
    RITUAL_OBJECTS(28),
    TOOLS_AND_DOMESTIC_IMPLEMENTS(29),
    CRAFTWORK(30),
    PAINTINGS(31),
    DRAWINGS(32),
    ENGRAVINGS(33),
    SCULPTURES(34),
    GRAPHICAL_SERIE_WORKS(35),
    WORKS(36),
    DECORATIVE_ARTS(37),
    ART_INSTALLATIONS(38),
    ELEMENTS_RELATED_TO_WORSHIP(39),
    FUNERARY_ELEMENTS(40),
    EVERYDAY_LIFE_ELEMENTS(41),
    MILITARY_OBJECTS(42),
    MUSICAL_INSTRUMENTS(43),
    NUMISMATIC_AND_PHILATELIC_ELEMENTS(44),
    COMMEMORATIVE_WORKS(45),
    UTIENSILS(46),
    INSTRUMENTS(47),
    WORK_TOOLS(48),
    TECHNOLOGICAL_EQUIPMENT(49),
    MACHINES(50),
    VEHICLES(51),
    BOOKS(52),
    SERIAL_PUBLICATIONS(53),
    ADMINISTRATIVE_ARCHIVES(54),
    MUSICAL_SCORES(55),
    MAPS_AND_OTHER_CARTOGRAPHIC_MATERIALS(56),
    PHOTOGRAPHS_AND_NEGATIVES(57),
    SOUND_MATERIAL_AND_MUSICAL_RECORDINGS(58),
    AUDIO_VISUAL_PRODUCTIONS(59),
    DIGITAL_OBJECTS_AND_MULTIMEDIA_CREATIONS(60),
    ELECTRONIC_RESOURCES(61),
    REMAINS_OF_STRUCTURES(62),
    ORNAMENTAL_ELEMENTS(63),
    FUNCTIONAL_ELEMENTS(64),
    LITERATURE(65),
    MUSIC(66),
    DANCE(67),
    THEATRE(68),
    CELEBRATION_SPORT_CHILDRENS_GAMES(69),
    LANGUAGE(70),
    DIALECT(71),
    TOPONYM(72),
    ORAL_EXPRESSION(73),
    LOCAL_MEMORY_LINKED_TO_HISTORICAL_EVENT_AND_PLACE(74),
    MUSICAL_PIECE(75),
    POPULAR_ANONYM_SONG(76),
    BELIEF(77),
    RITUAL_AND_RELIGIOUS_PRACTICE(78),
    TRADITIONAL_AND_COMMUNAL_PRACTICE(79),
    PEOPLES_BEHAVIOURAL_PATTERN(80),
    POPULAR_TRADITION(81),
    DIETARY_HABIT(82),
    COOKING_METHOD(83),
    TRADITIONAL_SCIENTIFIC_AND_HUMANISTIC_KNOWLEDGE(84),
    TRADITIONAL_ECOLOGICAL_KNOWLEDGE(85),
    USES_AND_KNOWLEDGE_OF_INDIGENOUS_PEOPLE(86),
    TRADITIONAL_HEALTH_AND_MEDICINE_PRACTICES_AND_KNOWLEDGE(87),
    TRADITIONAL_CRAFTSMANSHIP(88),
    SETTLEMENT_PATTERN_AND_TRADITIONAL_CONSTRUCTION_TECHNIQUE(89),
    TRADITIONAL_OCCUPATION(90),
    TRADITIONAL_PRODUCTIVE_TECHNIQUE_AND_KNOWLEDGE(91),
    TRADITIONAL_INSTITUTION(92),
    TRADITIONAL_RULES_OR_NORMS(93),
    CUSTOMARY_LEGAL_SYSTEM(94),
    SOCIAL_VALUE_SYSTEM(95),
    TRADITIONAL_SOCIAL_ORGANIZATION(96),
    NATURAL_PARK(97),
    GEOPARK(98),
    NATURAL_RESERVE(99),
    LANDSCAPE(100),
    WETLAND(101),
    MARINE_AREA(102),
    BIOSPHERE(103),
    AEOLIAN(104),
    CRYOGENIC_LANDFORMS(105),
    EROSION_LANDFORMS(106),
    FLUVIAL_LANDFORMS(107),
    IMPACT_LANDFORMS(108),
    KARST_LANDFORMS(109),
    LACUSTRINE_LANDFORMS(110),
    MOUNTAIN_AND_GLACIAL_LANDFORMS(111),
    SLOPE_LANDFORMS(112),
    TECTONIC_LANDFORMS(113),
    VOLCANIC_LANDFORMS(114),
    WEATHERING_LANDFORMS(115),
    ASTRONOMIC(116),
    FLOWEING(117),
    FISH_OVIPOSITION(118),
    INSECT_METAMORPHOSIS(119),
    ZEAL_AND_REPRODUCTION_OF_ANIMALS(120),
    MIGRATION(121),
    ATMOSPHERIC(122),
    GEOLOGICAL(123),
    CLOSED_FORESTS(124),
    WOODLANDS(125),
    FOURRES_THICKETS_OR_SHRUBLANDS(126),
    DWARF_SCRUB_AND_RELATED_COMMUNITIES(127),
    TERRESTRIAL_HERBACEOUS_COMMUNITIES(128),
    DESERTS_AND_OTHER_SCARCELY_VEGETATED_AREAS(129),
    AQUATIC_PLANT_FORMATIONS(130),
    BIRDS(131),
    MAMMALS(132),
    AMPHIBIANS(133),
    REPTILES(134),
    FISH(135),
    INSECTS(137),
    MOLLUSCS(136),
    AGRICULTURAL_LANDSCAPE(143),
    TREE(138),
    SACRED_NATURAL_LANDSCAPE(140),
    FLOWER(139),
    LANDSCAPE_OF_SPIRITUAL_SIGNIFICANCE(141),
    TRADITIONAL_KNOW_HOW(156),
    LANDSCAPE_OF_AESTHETIC_SIGNIFICANCE(142),
    HISTORIC_TOWN_OR_VILLAGE(151),
    PLANTATIONS_AND_CROPS(154),
    ARCHEOLOGICAL_SITE(144),
    SUSTAINABLE_LAND_USE(157),
    HISTORIC_SITE(145),
    CEMETERIES(150),
    CULTIVATION_PRACTICE(152),
    INDUSTRIAL_SITE(146),
    GARDEN_AND_PARKLAND_LANDSCAPE(148),
    ANIMAL_HUSBANDRY(155),
    PASTORAL_LANDSCAPE(147),
    BOTANICAL_GARDEN(149),
    FARMING_SYSTEM(153);

    private final Integer id;

    Tag(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    private static final Map<Integer, Tag> TAG_MAP = new HashMap<>();
    static {
        Arrays.stream(Tag.values())
                .forEach(tag -> TAG_MAP.put(tag.id, tag));
    }

    public static Tag fromId(Integer id) {
        return TAG_MAP.get(id);
    }
}