package com.ocity.api.core.infrastructure.heritage.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.NamedQueries;
import jakarta.persistence.NamedQuery;
import jakarta.persistence.Table;

@Entity
@Table(name = "heritage_field_tags")
@NamedQueries({
        @NamedQuery(
                name = FieldTagsEntity.FIND_TAGS_BY_IDS,
                query = " SELECT tags " +
                        " FROM FieldTagsEntity tags " +
                        " WHERE tags.id IN :tagsIds "
        )
})
public class FieldTagsEntity {

    public static final String FIND_TAGS_BY_IDS = "FieldTagsEntity.FIND_TAGS_BY_IDS";

    @Id
    private Integer id;

    private String name;

    @Column(name = "subtype_id")
    private Integer subtypeId;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getSubtypeId() {
        return subtypeId;
    }

    public void setSubtypeId(Integer subtypeId) {
        this.subtypeId = subtypeId;
    }

    @Override
    public String toString() {
        return "FieldTagsEntity{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", subtypeId=" + subtypeId +
                '}';
    }
}
