package com.ocity.api.core.infrastructure.heritage.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.Table;

import java.util.Date;

@Entity
@Table(name = "heritage_list")
public class HeritageListEntity {

    @Id
    private Integer id;

    private String name;

    private Date date;

    @Column(name = "country_id")
    private Integer countryId;

    @Column(name = "state_id")
    private Integer stateId;

    @Column(name = "city_id")
    private Integer cityId;

    private String organization;

    private String ownership;

    private String periodicity;

    private String email;

    @Column(name = "image_copyright")
    private String imageCopyright;

    private String image;

    @Column(name = "heritage_field_id")
    private Integer heritageFieldId;

    @Column(name = "short_heritage_description")
    private String shortHeritageDescription;

    @Column(name = "extended_heritage_description")
    private String extendedHeritageDescription;

    @Column(name = "short_local_heritage_description")
    private String shortLocalHeritageDescription;

    @Column(name = "extended_local_heritage_description")
    private String extendedLocalHeritageDescription;

    private String tags;

    private String subtype;

    private String documentation;

    @Column(name = "is_museum")
    private Boolean isMuseum;

    @Column(name = "is_protected")
    private Boolean isProtected;

    @Column(name = "is_verified")
    private Boolean isVerified;

    @Column(name = "protected_values")
    private String protectedValues;

    private Double latitude;

    private Double longitude;

    @Column(name = "created_at")
    private Date createdAt;

    @Column(name = "updated_at")
    private Date updatedAt;

    @Column(name = "deleted_at")
    private Date deletedAt;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public Integer getCountryId() {
        return countryId;
    }

    public void setCountryId(Integer countryId) {
        this.countryId = countryId;
    }

    public Integer getStateId() {
        return stateId;
    }

    public void setStateId(Integer stateId) {
        this.stateId = stateId;
    }

    public Integer getCityId() {
        return cityId;
    }

    public void setCityId(Integer cityId) {
        this.cityId = cityId;
    }

    public String getOrganization() {
        return organization;
    }

    public void setOrganization(String organization) {
        this.organization = organization;
    }

    public String getOwnership() {
        return ownership;
    }

    public void setOwnership(String ownership) {
        this.ownership = ownership;
    }

    public String getPeriodicity() {
        return periodicity;
    }

    public void setPeriodicity(String periodicity) {
        this.periodicity = periodicity;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getImageCopyright() {
        return imageCopyright;
    }

    public void setImageCopyright(String imageCopyright) {
        this.imageCopyright = imageCopyright;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public Integer getHeritageFieldId() {
        return heritageFieldId;
    }

    public void setHeritageFieldId(Integer heritageFieldId) {
        this.heritageFieldId = heritageFieldId;
    }

    public String getShortHeritageDescription() {
        return shortHeritageDescription;
    }

    public void setShortHeritageDescription(String shortHeritageDescription) {
        this.shortHeritageDescription = shortHeritageDescription;
    }

    public String getExtendedHeritageDescription() {
        return extendedHeritageDescription;
    }

    public void setExtendedHeritageDescription(String extendedHeritageDescription) {
        this.extendedHeritageDescription = extendedHeritageDescription;
    }

    public String getShortLocalHeritageDescription() {
        return shortLocalHeritageDescription;
    }

    public void setShortLocalHeritageDescription(String shortLocalHeritageDescription) {
        this.shortLocalHeritageDescription = shortLocalHeritageDescription;
    }

    public String getExtendedLocalHeritageDescription() {
        return extendedLocalHeritageDescription;
    }

    public void setExtendedLocalHeritageDescription(String extendedLocalHeritageDescription) {
        this.extendedLocalHeritageDescription = extendedLocalHeritageDescription;
    }

    public String getTags() {
        return tags;
    }

    public void setTags(String tags) {
        this.tags = tags;
    }

    public String getSubtype() {
        return subtype;
    }

    public void setSubtype(String subtype) {
        this.subtype = subtype;
    }

    public String getDocumentation() {
        return documentation;
    }

    public void setDocumentation(String documentation) {
        this.documentation = documentation;
    }

    public Boolean getMuseum() {
        return isMuseum;
    }

    public void setMuseum(Boolean museum) {
        isMuseum = museum;
    }

    public Boolean getProtected() {
        return isProtected;
    }

    public void setProtected(Boolean aProtected) {
        isProtected = aProtected;
    }

    public Boolean getVerified() {
        return isVerified;
    }

    public void setVerified(Boolean verified) {
        isVerified = verified;
    }

    public String getProtectedValues() {
        return protectedValues;
    }

    public void setProtectedValues(String protectedValues) {
        this.protectedValues = protectedValues;
    }

    public Double getLatitude() {
        return latitude;
    }

    public void setLatitude(Double latitude) {
        this.latitude = latitude;
    }

    public Double getLongitude() {
        return longitude;
    }

    public void setLongitude(Double longitude) {
        this.longitude = longitude;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Date getDeletedAt() {
        return deletedAt;
    }

    public void setDeletedAt(Date deletedAt) {
        this.deletedAt = deletedAt;
    }
}
