package com.ocity.api.core.infrastructure.locations.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.NamedQuery;
import jakarta.persistence.Table;

import java.util.Date;

@Entity
@Table(name = "cities")
@NamedQuery(
        name = CityEntity.FIND_CITIES_BY_STATE_ID,
        query = " SELECT new CityEntity(c.id, c.name) " +
                " FROM CityEntity c " +
                " WHERE c.stateId = :stateId "
)
public class CityEntity {

    public static final String FIND_CITIES_BY_STATE_ID = "CityEntity.FIND_CITIES_BY_STATE_ID";

    public CityEntity() {
    }

    public CityEntity(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    @Id
    private Integer id;

    private String name;

    @Column(name = "state_id")
    private Integer stateId;

    @Column(name = "state_code")
    private String stateCode;

    @Column(name = "country_id")
    private Integer countryId;

    @Column(name = "country_code")
    private String countryCode;

    private Long latitude;

    private Long longitude;

    @Column(name = "created_at")
    private Date createdAt;

    @Column(name = "updated_at")
    private Date updatedAt;

    private Boolean flag;

    @Column(name = "wikidataid")
    private String wikiDataId;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getStateId() {
        return stateId;
    }

    public void setStateId(Integer stateId) {
        this.stateId = stateId;
    }

    public String getStateCode() {
        return stateCode;
    }

    public void setStateCode(String stateCode) {
        this.stateCode = stateCode;
    }

    public Integer getCountryId() {
        return countryId;
    }

    public void setCountryId(Integer countryId) {
        this.countryId = countryId;
    }

    public String getCountryCode() {
        return countryCode;
    }

    public void setCountryCode(String countryCode) {
        this.countryCode = countryCode;
    }

    public Long getLatitude() {
        return latitude;
    }

    public void setLatitude(Long latitude) {
        this.latitude = latitude;
    }

    public Long getLongitude() {
        return longitude;
    }

    public void setLongitude(Long longitude) {
        this.longitude = longitude;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Boolean getFlag() {
        return flag;
    }

    public void setFlag(Boolean flag) {
        this.flag = flag;
    }

    public String getWikiDataId() {
        return wikiDataId;
    }

    public void setWikiDataId(String wikiDataId) {
        this.wikiDataId = wikiDataId;
    }
}
