package com.ocity.api.core.infrastructure.locations.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.NamedQuery;
import jakarta.persistence.Table;

import java.util.Date;

@Entity
@Table(name = "regions")
@NamedQuery(
        name = RegionEntity.FIND_ALL_REGIONS,
        query = " SELECT new RegionEntity(r.id, r.name) " +
                " FROM RegionEntity r "
)
public class RegionEntity {

    public static final String FIND_ALL_REGIONS = "RegionEntity.FIND_ALL_REGIONS";

    public RegionEntity() {
    }

    public RegionEntity(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    @Id
    private Integer id;

    private String name;

    private String translations;

    @Column(name = "created_at")
    private Date createdAt;

    @Column(name = "updated_at")
    private Date updatedAt;

    private Boolean flag;

    @Column(name = "wikidataid")
    private String wikiDataId;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getTranslations() {
        return translations;
    }

    public void setTranslations(String translations) {
        this.translations = translations;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Boolean getFlag() {
        return flag;
    }

    public void setFlag(Boolean flag) {
        this.flag = flag;
    }

    public String getWikiDataId() {
        return wikiDataId;
    }

    public void setWikiDataId(String wikiDataId) {
        this.wikiDataId = wikiDataId;
    }
}
