package com.ocity.api.core.infrastructure.locations.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.NamedQuery;
import jakarta.persistence.Table;

import java.util.Date;

@Entity
@Table(name = "states")
@NamedQuery(
        name = StateEntity.FIND_STATES_BY_COUNTRY_ID,
        query = " SELECT new StateEntity(s.id, s.name) " +
                " FROM StateEntity s " +
                " WHERE s.countryId = :countryId "
)
public class StateEntity {

    public static final String FIND_STATES_BY_COUNTRY_ID = "StateEntity.FIND_STATES_BY_COUNTRY_ID";

    public StateEntity() {
    }

    public StateEntity(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    @Id
    private Integer id;

    private String name;

    @Column(name = "country_id")
    private Integer countryId;

    @Column(name = "country_code")
    private String countryCode;

    @Column(name = "fips_code")
    private String fipsCode;

    private String iso2;

    private String type;

    private Long latitude;

    private Long longitude;

    @Column(name = "created_at")
    private Date createdAt;

    @Column(name = "updated_at")
    private Date updatedAt;

    private boolean flag;

    @Column(name = "wikidataid")
    private String wikiDataId;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Long getLatitude() {
        return latitude;
    }

    public void setLatitude(Long latitude) {
        this.latitude = latitude;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public boolean isFlag() {
        return flag;
    }

    public void setFlag(boolean flag) {
        this.flag = flag;
    }

    public String getWikiDataId() {
        return wikiDataId;
    }

    public void setWikiDataId(String wikiDataId) {
        this.wikiDataId = wikiDataId;
    }

    public Long getLongitude() {
        return longitude;
    }

    public void setLongitude(Long longitude) {
        this.longitude = longitude;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getIso2() {
        return iso2;
    }

    public void setIso2(String iso2) {
        this.iso2 = iso2;
    }

    public String getFipsCode() {
        return fipsCode;
    }

    public void setFipsCode(String fipsCode) {
        this.fipsCode = fipsCode;
    }

    public String getCountryCode() {
        return countryCode;
    }

    public void setCountryCode(String countryCode) {
        this.countryCode = countryCode;
    }

    public Integer getCountryId() {
        return countryId;
    }

    public void setCountryId(Integer countryId) {
        this.countryId = countryId;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }
}
