package com.ocity.api.core.infrastructure.locations.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.NamedQueries;
import jakarta.persistence.NamedQuery;
import jakarta.persistence.Table;

import java.util.Date;

@Entity
@Table(name = "subregions")
@NamedQueries({
        @NamedQuery(
                name = SubregionEntity.FIND_ALL_SUBREGIONS,
                query = " SELECT new SubregionEntity(s.id, s.name, s.regionId) " +
                        " FROM SubregionEntity s "
        ),
        @NamedQuery(
                name = SubregionEntity.FIND_SUBREGIONS_BY_REGION_ID,
                query = " SELECT new SubregionEntity(s.id, s.name, s.regionId) " +
                        " FROM SubregionEntity s " +
                        " WHERE s.regionId = :regionId "
        )
})
public class SubregionEntity {

    public static final String FIND_ALL_SUBREGIONS = "SubregionEntity.FIND_ALL_SUBREGIONS";
    public static final String FIND_SUBREGIONS_BY_REGION_ID = "SubregionEntity.FIND_SUBREGIONS_BY_REGION_ID";

    public SubregionEntity() {
    }

    public SubregionEntity(Integer id, String name, Integer regionId) {
        this.id = id;
        this.name = name;
        this.regionId = regionId;
    }

    @Id
    private Integer id;

    private String name;

    private String translations;

    @Column(name = "region_id")
    private Integer regionId;

    @Column(name = "created_at")
    private Date createdAt;

    @Column(name = "updated_at")
    private Date updatedAt;

    private Boolean flag;

    @Column(name = "wikidataid")
    private String wikiDataId;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getTranslations() {
        return translations;
    }

    public void setTranslations(String translations) {
        this.translations = translations;
    }

    public Integer getRegionId() {
        return regionId;
    }

    public void setRegionId(Integer regionId) {
        this.regionId = regionId;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Boolean getFlag() {
        return flag;
    }

    public void setFlag(Boolean flag) {
        this.flag = flag;
    }

    public String getWikiDataId() {
        return wikiDataId;
    }

    public void setWikiDataId(String wikiDataId) {
        this.wikiDataId = wikiDataId;
    }
}
