package com.ocity.api.login.application;

import com.ocity.api.login.domain.Email;
import com.ocity.api.login.domain.LoginRepository;
import com.ocity.api.login.domain.Password;
import com.ocity.api.login.domain.User;
import com.ocity.api.login.infrastructure.dto.out.LoginDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class LogIn {

    private final LoginRepository loginRepository;

    @Autowired
    public LogIn(LoginRepository loginRepository) {
        this.loginRepository = loginRepository;
    }

    public LoginDTO execute(String email, String password) {
        final User user = loginRepository.manageLogin(new Email(email), new Password(password));

        return mapLoginDTO(user);
    }

    private LoginDTO mapLoginDTO(User user) {
        return new LoginDTO(user.apiKey, user.roles);
    }
}
