package com.ocity.api.login.infrastructure.client;

import com.ocity.api.login.domain.Email;
import com.ocity.api.login.domain.Password;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.reactive.function.BodyInserters;
import org.springframework.web.reactive.function.client.WebClient;

@Service
public class LoginClient {

//    private static final String AUTH_URL = "/api/v1_1/auth/login";
//    private static final String AUTH_URL = "/api/v1_1/auth/users";
    private static final String AUTH_URL = "http://localhost:8080/mock"; //TODO remove after integration

    @Value("${com.ocity.host}")
    private String AUTH_HOST;

    private final WebClient webClient;

    public LoginClient(WebClient.Builder webClientBuilder) {
        this.webClient = webClientBuilder.baseUrl(AUTH_HOST).build();
    }

    public LoginResponse executeLogin(Email email, Password password) {
        LoginRequest loginRequest = new LoginRequest(email.value(), password.value());

        return webClient.post()
                .uri(AUTH_URL)
                .bodyValue(BodyInserters.fromValue(loginRequest))
                .retrieve()
                .bodyToMono(LoginResponse.class)
                .block();
    }

    public void superAdmin() {
        webClient.get()
                .uri("/users")
                .retrieve()
                .bodyToMono(String.class)
                .block();
    }
}
