document.addEventListener('DOMContentLoaded', () => {
    fetch('toolbar.html')
        .then(response => response.text())
        .then(data => document.getElementById('toolbar-container').innerHTML = data)

    document.getElementById('login-form').addEventListener('submit', function (event) {
        event.preventDefault();
        const email = document.getElementById('email').value;
        const password = document.getElementById('password').value;

        const data = {
            email: email,
            password: password
        };

        const jsonData = JSON.stringify(data);

        fetch('/login', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            credentials: 'include',
            body: jsonData
        })
            .then(response => {
                if (!response.ok) {
                    return response.json().then(error => {
                        throw new Error(error.message);
                    });
                }
                return response.json();
            })
            .then(response => {
                if (response.roles.includes('USER')) {
                    window.location.replace('user_data.html');
                } else if (response.roles.includes('SUPERADMIN')) {
                    window.location.replace('superadmin.html');
                } else {
                    const errorMessage = document.getElementById('error-message');
                    errorMessage.textContent = 'Login failed. User does not have the required roles to access this API.';
                    errorMessage.style.display = 'block';
                }
            })
            .catch(error => {
                console.error('Login failed. Status:', error);
                const errorMessage = document.getElementById('error-message');
                errorMessage.textContent = 'Login failed. Please check your credentials and try again.';
                errorMessage.style.display = 'block';
            });
    });

});