waitForElementToLoad('.toolbar').then(() => {
    const currentURL = window.location.pathname;

    const accountTab = document.getElementById('account-tab');
    const documentationTab = document.getElementById('documentation-tab');

    if (currentURL.includes('user_data.html')) {
        accountTab.classList.add('active');
        accountTab.style.pointerEvents = 'none';
    } else if (currentURL.includes('swagger_documentation.html')) {
        documentationTab.classList.add('active');
        documentationTab.style.pointerEvents = 'none';
    }
});

function waitForElementToLoad(selector) {
    return new Promise(resolve => {
        if (document.querySelector(selector)) {
            return resolve(document.querySelector(selector));
        }

        const observer = new MutationObserver(() => {
            if (document.querySelector(selector)) {
                observer.disconnect();
                resolve(document.querySelector(selector));
            }
        });

        observer.observe(document.body, {
            childList: true,
            subtree: true
        });
    });
}
