package com.ocity.api.locations.application.dto.out;

import com.ocity.api.core.application.locations.dto.out.CityDTO;
import com.ocity.api.core.application.locations.dto.out.CityDTOMapper;
import com.ocity.api.core.domain.locations.City;
import com.ocity.api.core.domain.locations.CityId;
import com.ocity.api.core.domain.locations.Name;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNull;

class CityDTOMapperTest {

    private static final int ID = 1;
    private static final String NAME = "City";

    private final CityDTOMapper cityDTOMapper = new CityDTOMapper();

    @Test
    void testMap() {
        CityDTO dto = cityDTOMapper.map(buildCity());

        assertEquals(ID, dto.id);
        assertEquals(NAME, dto.name);
    }

    @Test
    void testMap_WhenCityIsNull() {
        assertNull(cityDTOMapper.map(null));
    }

    private City buildCity() {
        return new City(new CityId(ID), new Name(NAME));
    }
}