package com.ocity.api.locations.application.dto.out;

import com.ocity.api.core.application.locations.dto.out.RegionDTO;
import com.ocity.api.core.application.locations.dto.out.RegionDTOMapper;
import com.ocity.api.core.domain.locations.Name;
import com.ocity.api.core.domain.locations.Region;
import com.ocity.api.core.domain.locations.RegionId;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNull;

class RegionDTOMapperTest {

    private static final int ID = 1;
    private static final String NAME = "Region";

    private final RegionDTOMapper regionDTOMapper = new RegionDTOMapper();

    @Test
    void testMap() {
        RegionDTO dto = regionDTOMapper.map(buildRegion());

        assertEquals(ID, dto.id);
        assertEquals(NAME, dto.name);
    }

    @Test
    void testMap_WhenRegionIsNull() {
        assertNull(regionDTOMapper.map(null));
    }

    private Region buildRegion() {
        return new Region(new RegionId(ID), new Name(NAME));
    }
}