package com.ocity.api.locations.application.dto.out;

import com.ocity.api.core.application.locations.dto.out.StateDTO;
import com.ocity.api.core.application.locations.dto.out.StateDTOMapper;
import com.ocity.api.core.domain.locations.Name;
import com.ocity.api.core.domain.locations.State;
import com.ocity.api.core.domain.locations.StateId;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNull;

class StateDTOMapperTest {

    private static final int ID = 1;
    private static final String NAME = "State";

    private final StateDTOMapper stateDTOMapper = new StateDTOMapper();

    @Test
    void testMap() {
        StateDTO dto = stateDTOMapper.map(buildState());

        assertEquals(ID, dto.id);
        assertEquals(NAME, dto.name);
    }

    @Test
    void testMap_WhenStateIsNull() {
        assertNull(stateDTOMapper.map(null));
    }

    private State buildState() {
        return new State(new StateId(ID), new Name(NAME));
    }

}